/*!
    \file version.h
    \brief Version definition
    \author Ivan Shynkarenka
    \date 18.01.2016
    \copyright MIT License
*/

#ifndef CPPCOMMON_VERSION_H
#define CPPCOMMON_VERSION_H

/*! \mainpage C++ Common Library

C++ Common Library contains reusable components  and  patterns  for  error  and
exceptions  handling,  filesystem  manipulations,  math,  string   format   and
encoding, shared memory, threading, time management and others.

This document contains CppCommon API references.

Library description, features, requirements and usage examples can be  find  on
GitHub: https://github.com/chronoxor/CppCommon

*/

/*!
    \namespace CppCommon
    \brief C++ Common project definitions
*/
namespace CppCommon {

//! Project version
const char version[] = "1.0.4.1";

} // namespace CppCommon

#endif // CPPCOMMON_VERSION_H
